package l04_classes;

public class Car {

	private final String brand;
	private final int yearOfProduction;
	private final int tankCapacity;
	private final double fuelConsumption;
	private int mileage;
	private int currentFuelLevel;

	public Car(String brand, int yearOfProduction, int tankCapacity, double fuelConsumption) {
		this.brand = brand;
		this.yearOfProduction = yearOfProduction;
		this.tankCapacity = tankCapacity;
		this.fuelConsumption = fuelConsumption;
		this.mileage = 0;
		this.currentFuelLevel = 0;
	}


	public void refueling (int litres) {
		System.out.println("Getting " + litres + " litres");
		currentFuelLevel += litres;
		if (currentFuelLevel > tankCapacity) {
			currentFuelLevel = tankCapacity;
		}
	}

	public void driving (int miles) {
		System.out.println("I'm driving " + miles + " miles");
		if (miles * fuelConsumption / 100. <= currentFuelLevel) {
			currentFuelLevel -= (int)(miles * fuelConsumption / 100.);
			mileage += miles;
		} else {
			miles = (int)(100. * currentFuelLevel / fuelConsumption);
			currentFuelLevel = 0;
			mileage = miles;
		}
	}

	@Override
	public String toString() {
		return "brand = '" + brand + '\'' +
			"\nyearOfProduction = " + yearOfProduction +
			"\ntankCapacity = " + tankCapacity +
			"\nfuelConsumption = " + fuelConsumption +
			"\nmileage = " + mileage +
			"\ncurrentFuelLevel = " + currentFuelLevel + "\n";
	}
}
