package l04_classes;
import java.util.Objects;

public class EqualsMethod2Over {

	static class ValueWithEquals {
		private final int n;
		public ValueWithEquals(int n) {
			this.n = n;
		}

		// equals consistency: objects that are equal to each other must return the same hashCode
		// collisions: unequal objects may have the same hashCode

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (!(o instanceof ValueWithEquals that)) return false;
			return n == that.n;
		}

		@Override
		public int hashCode() {
			return Objects.hash(n);
		}
	}

	public static void main(String[] args) {
		ValueWithEquals v1 = new ValueWithEquals(200);
		ValueWithEquals v2 = new ValueWithEquals(200);
		ValueWithEquals v3 = new ValueWithEquals(300);

		System.out.println("v1.hashCode(): " + v1.hashCode());
		System.out.println("v2.hashCode(): " + v2.hashCode());
		System.out.println("v3.hashCode(): " + v3.hashCode());
		System.out.println("v1.equals(v2): " + v1.equals(v2));
		System.out.println("v1.equals(v3): " + v1.equals(v3));
	}
} 

