package l04_classes;

public class Point {

	private static final int MIN_X = 0;
	private static final int MIN_Y = 0;
	private static final int MAX_X = 100;
	private static final int MAX_Y = 100;
	private final String name;
	private double x, y;

	public Point(String name) {
		this.name = name;
	}

	public Point(String name, double x, double y) {
		this.name = name;
		setX(x);
		setY(y);
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}

	public void setX(double x) {
		// MIN_X <= x <= MAX_X
		this.x = Math.min(MAX_X, Math.max(MIN_X, x));
	}

	public void setY(double y) {
		// MIN_X <= y <= MAX_Y
		this.y = Math.min(MAX_Y, Math.max(MIN_Y, y));
	}

	void move(double x, double y) {
		setX(this.x + x);
		setY(this.y + y);
	}

	@Override
	public String toString() {
		return String.format("%s: (%.2f, %.2f)", name, x, y);
	}

}

