package l04_classes;

public class PointWithCounter implements AutoCloseable {

	private final int x;
	private final int y;
	private static int numberOfPoints = 0;

	public PointWithCounter(int x, int y) {
		this.x = x;
		this.y = y;
		++numberOfPoints;
	}

	public static int getNumberOfPoints() {
		return numberOfPoints;
	}

	@Override
	public void close() {
		--numberOfPoints;
	}

	@Override
	public String toString() {
		return String.format("(%d, %d), no points = %d", x, y, numberOfPoints);
	}
}
