package l04_classes;

public final class Singleton {

    private int value = 0;

//	when Singleton class is loaded, the instance of SingletonHolder will not be
//	created until getInstance() method is called. This approach is thread-safe

    private Singleton() {
        System.out.println("--- Singleton()");
    }

    private static class SingletonHolder {
        // static member field; initialized once
        private static final Singleton INSTANCE = new Singleton();
    }

    public static Singleton getInstance() {
        return SingletonHolder.INSTANCE;
    }

    public void setValue(int value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return "value = " + value;
    }
}
