package l04_classes;

public class Vector {
	private final double x;
	private final double y;
	private final double z;

	public Vector (double x, double y, double z) {
		this.x = x;
		this.y = y;
		this.z = z;
	}

	public Vector add (Vector v) {
		return new Vector(x + v.x, y + v.y, z + v.z);
	}

	public double dotProduct (Vector v) {
		return x*v.x + y*v.y + z*v.z;
	}

	public Vector crossProduct (Vector v) {
		return new Vector(y*v.z - v.y*z, z*v.x - x*v.z, x*v.y - y*v.x);
	}

	public Vector multiplyByScalar(double s) {
		return new Vector(s*x, s*y, s*z);
	}

	@Override
	public String toString() {
		return String.format("(%.1f, %.1f, %.1f)", x, y, z);
	}
}
